import iRRAPy.RRAresult as rres
from math import sqrt

class Average:
    def __init__(self, av, sd, med):
        self.average = av
        self.std_deviation = sd
        self.median = med
        
""" computes the average RRA of a list of RRAresult objects. It returns a
Average object: average, standard deviation and median(s) (the last one as
a list)"""
def rra_average(results_list, prin = True):
    n = len(results_list)
    if n%2 == 0:
        m1 = (n/2)-1
        m2 = m1 + 1
    else:
        m1 = ((n+1)/2)-1
        m2 = -1

    results_list.sort(key = lambda x: x.getRRA())
    
    """Median"""
    if m2 == -1:
        med = [results_list[int(m1)].getRRA()]
    else:
        med = [results_list[int(m1)].getRRA(), results_list[int(m2)].getRRA()]
    
    """Average"""
    sum = 0
    for x in results_list:
        sum += x.getRRA()
    mean = sum/n
    
    """Standard deviation"""
    sum = 0
    for x in results_list:
        sum += ((x.getRRA() - mean)**2)
    variance = sum/n
    sigma = sqrt(variance)
    
    if prin:
        if m2 == -1:
            print("The average RRA is ", mean, ". Standard deviation = ",
                sigma, ", median = ", med[0], sep = "")
        else:
            print("The average RRA is ", mean, ". Standard deviation = ",
                sigma, ", median = ", med[0], "-", med[1], sep = "")
    
    return Average(mean, sigma, med)